#include <bits/stdc++.h>

using namespace std;

int main(){
    int n;cin >> n;
    int zalihe[4];
    for(int i = 0;i < 4;i++){
        cin >> zalihe[i];
    }
    string grupa[n];
    int jedinice[n];
    for(int i = 0;i < n;i++){
        cin >> grupa[i] >> jedinice[i];
    }
    int dodeljeno[n][4] = {0};
    bool moguce = true;
    for(int i = 0;i < n;i++){
        if(grupa[i] == "O"){
            if(jedinice[i] > zalihe[0]){
                moguce = false;
            }
            else{
                dodeljeno[i][0] += jedinice[i];
                zalihe[0] -= jedinice[i];
            }
        }
        else if(grupa[i] == "A"){
            if(jedinice[i] <= zalihe[1]){
                dodeljeno[i][1] += jedinice[i];
                zalihe[1] -= jedinice[i];
            }
            else if(jedinice[i] > zalihe[1]){
                if(zalihe[1] + zalihe[0] >= jedinice[i]){
                    dodeljeno[i][1] += zalihe[1];
                    zalihe[1] = 0;
                    dodeljeno[i][0] += jedinice[i];
                    zalihe[0] -= jedinice[i];
                }
            }
            else if(jedinice[i] > zalihe[0]){
                if(zalihe[0] + zalihe[1] > jedinice[i]){
                    dodeljeno[i][0] += zalihe[0];
                    jedinice[i] -= zalihe[0];
                    zalihe[0] = 0;
                    dodeljeno[i][1] += jedinice[i];
                    zalihe[1] -= jedinice[i];
                }
            }
            else if(zalihe[0] >= jedinice[i]){
                dodeljeno[i][0] += jedinice[i];
                zalihe[0] -= jedinice[i];
            }
            else if(zalihe[1] < jedinice[i] && zalihe[0] >= jedinice[i]){
                dodeljeno[i][0] += jedinice[i];
                jedinice[i] = 0;
                zalihe[0] -= jedinice[i];
            }
            else{
                moguce = false;
            }
        }
        else if(grupa[i] == "B"){
            if(jedinice[i] < zalihe[2]){
                dodeljeno[i][2] += jedinice[i];
                zalihe[2] -= jedinice[i];
            }
            else if(jedinice[i] > zalihe[2]){
                if(zalihe[2] + zalihe[0] > jedinice[i]){
                    dodeljeno[i][2] += zalihe[2];
                    jedinice[i] -= zalihe[2];
                    zalihe[2] = 0;
                    dodeljeno[i][0] += jedinice[i];
                    zalihe[0] -= jedinice[i];
                }
                else{
                    moguce = false;
                }
            }
            else if(jedinice[i] >= zalihe[0]){
                if(zalihe[0] + zalihe[2] >= jedinice[i]){
                    dodeljeno[i][0] += zalihe[0];
                    jedinice[i] -= zalihe[0];
                    zalihe[0] = 0;
                    dodeljeno[i][2] += jedinice[i];
                    zalihe[2] -= jedinice[i];
                }
                else{
                    moguce = false;
                }
            }
            else if(zalihe[2] < jedinice[i] && zalihe[0] >= jedinice[i]){
                dodeljeno[i][0] += jedinice[i];
                jedinice[i] = 0;
                zalihe[0] -= jedinice[i];
            }

        }
        else if(grupa[i] == "AB"){
            if(zalihe[3] >= jedinice[i]){
                dodeljeno[i][3] += jedinice[i];
                zalihe[3] -= jedinice[i];
            }
            else if(jedinice[i] > zalihe[3]){
                if(zalihe[3] + zalihe[0] >= jedinice[i]){
                    dodeljeno[i][3] += zalihe[3];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][0] += jedinice[i];
                    zalihe[0] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[3] + zalihe[1] >= jedinice[i]){
                    dodeljeno[i][3] += zalihe[3];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][1] += jedinice[i];
                    zalihe[1] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[3] + zalihe[2] >= jedinice[i]){
                    dodeljeno[i][3] += zalihe[3];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][2] += jedinice[i];
                    zalihe[2] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[2] + zalihe[1] >= jedinice[i]){
                    dodeljeno[i][2] += zalihe[2];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][1] += jedinice[i];
                    zalihe[1] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[2] + zalihe[0] >= jedinice[i]){
                    dodeljeno[i][3] += zalihe[3];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][0] += jedinice[i];
                    zalihe[0] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[1] + zalihe[0] >= jedinice[i]){
                    dodeljeno[i][3] += zalihe[3];
                    jedinice[i] -= zalihe[3];
                    dodeljeno[i][0] += jedinice[i];
                    zalihe[0] -= jedinice[i];
                    jedinice[i] = 0;
                }
                else if(zalihe[0] == 0 && zalihe[1] == 0 && zalihe[3] == 0 && zalihe[2] > jedinice[i]){
                    dodeljeno[i][2] += (jedinice[i] - zalihe[2]);
                    zalihe[2] -= jedinice[i];
                }
                else if(zalihe[2] == 0 && zalihe[1] == 0 && zalihe[3] == 0 && zalihe[1] > jedinice[i]){
                    dodeljeno[i][1] += (jedinice[i] - zalihe[1]);
                    zalihe[1] -= jedinice[i];
                }
                else if(zalihe[3] == 0 && zalihe[1] == 0 && zalihe[2] == 0 && zalihe[0] > jedinice[i]){
                    dodeljeno[i][0] += (jedinice[i] - zalihe[0]);
                    zalihe[0] -= jedinice[i];
                }
                else{
                    moguce = false;
                }
            }

        }
    }
    if(moguce){
        cout << "moguce" << endl;
        for(int i = 0;i < n;i++){
            for(int j = 0;j < 4;j++){
                cout << dodeljeno[i][j] << " ";
            }
            cout << endl;
        }
    }
    else{
        cout << "nemoguce" << endl;
    }
	return 0;
}